diff --git a/web/pgadmin/browser/static/js/layout.js b/web/pgadmin/browser/static/js/layout.js
index 54046bf2b..5f3138675 100644
--- a/web/pgadmin/browser/static/js/layout.js
+++ b/web/pgadmin/browser/static/js/layout.js
@@ -89,7 +89,7 @@ _.extend(pgBrowser, {
           browser.reflectLocklayoutChange(docker);
         });
       }
-    }, 500);
+    }, 5000);
   },
 
   reflectLocklayoutChange: function(docker) {
diff --git a/web/pgadmin/browser/static/js/node.js b/web/pgadmin/browser/static/js/node.js
index 7d91ea729..fef519b22 100644
--- a/web/pgadmin/browser/static/js/node.js
+++ b/web/pgadmin/browser/static/js/node.js
@@ -10,13 +10,13 @@
 import {getNodeView, removeNodeView} from './node_view';
 
 define('pgadmin.browser.node', [
-  'sources/tree/pgadmin_tree_node', 'sources/url_for',
+  'sources/url_for',
   'sources/gettext', 'jquery', 'underscore', 'sources/pgadmin',
   'pgadmin.browser.menu', 'backbone', 'pgadmin.alertifyjs', 'pgadmin.browser.datamodel',
   'backform', 'sources/browser/generate_url', 'pgadmin.help', 'sources/utils',
   'pgadmin.browser.utils', 'pgadmin.backform',
 ], function(
-  pgadminTreeNode, url_for,
+  url_for,
   gettext, $, _, pgAdmin,
   Menu, Backbone, Alertify, pgBrowser,
   Backform, generateUrl, help,
@@ -269,8 +269,7 @@ define('pgadmin.browser.node', [
       if (itemData._type == 'database' && !itemData.allowConn)
         return false;
 
-      var node = pgBrowser.Nodes[itemData._type],
-        parentData = node.getTreeNodeHierarchy(item);
+      var parentData = pgBrowser.tree.getTreeNodeHierarchy(item);
       if (_.indexOf(['create', 'insert', 'update', 'delete'], data.script) != -1) {
         if (itemData.type == 'role' &&
           parentData.server.user.can_create_role) {
@@ -325,7 +324,7 @@ define('pgadmin.browser.node', [
         }
 
         // We know - which data model to be used for this object.
-        var info = this.getTreeNodeHierarchy.apply(this, [item]),
+        var info = pgBrowser.tree.getTreeNodeHierarchy(item),
           newModel = new(this.model.extend({
             urlRoot: urlBase,
           }))(
@@ -450,7 +449,7 @@ define('pgadmin.browser.node', [
                 },
                 error: function(model, xhr, options) {
                   var _label = that && item ?
-                    that.getTreeNodeHierarchy(
+                    pgBrowser.tree.getTreeNodeHierarchy(
                       item
                     )[that.type].label : '';
                   pgBrowser.Events.trigger(
@@ -594,7 +593,7 @@ define('pgadmin.browser.node', [
       show_obj_properties: function(args, item) {
         var t = pgBrowser.tree,
           i = (args && args.item) || item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined,
+          d = i ? t.itemData(i) : undefined,
           o = this,
           l = o.title.apply(this, [d]);
 
@@ -786,7 +785,7 @@ define('pgadmin.browser.node', [
           obj = this,
           t = pgBrowser.tree,
           i = input.item || item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+          d = i ? t.itemData(i) : undefined;
 
         if (!d)
           return;
@@ -882,7 +881,7 @@ define('pgadmin.browser.node', [
           obj,
           t = pgBrowser.tree,
           i = item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+          d = i ? t.itemData(i) : undefined;
 
         if (!d)
           return;
@@ -920,7 +919,7 @@ define('pgadmin.browser.node', [
         var preference = pgBrowser.get_preference('sqleditor', 'copy_sql_to_query_tool');
         var t = pgBrowser.tree,
           i = item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+          d = i ? t.itemData(i) : undefined;
 
         if (!d)
           return;
@@ -944,7 +943,7 @@ define('pgadmin.browser.node', [
         var input = args || {},
           t = pgBrowser.tree,
           i = input.item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+          d = i  ? t.itemData(i) : undefined;
         pgBrowser.psql.psql_tool(d, i, true);
       },
 
@@ -988,32 +987,7 @@ define('pgadmin.browser.node', [
           }
         }
       },
-      added: function(item, data, browser) {
-        var b = browser || pgBrowser,
-          t = b.tree,
-          pItem = t.parent(item),
-          pData = pItem && t.itemData(pItem),
-          pNode = pData && pgBrowser.Nodes[pData._type];
-
-        // Check node is a collection or not.
-        if (pNode && pNode.is_collection) {
-          /* If 'collection_count' is not present in data
-           * it means tree node expanded first time, so we will
-           * kept collection count and label in data itself.
-           */
-          if (!('collection_count' in pData)) {
-            pData.collection_count = 0;
-          }
-          pData.collection_count++;
-          t.setLabel(
-            pItem, {
-              label: (
-                _.escape(pData._label) + ' <span>(' + pData.collection_count + ')</span>'
-              ),
-            }
-          );
-        }
-
+      added: function(item, data) {
         pgBrowser.Events.trigger('pgadmin:browser:tree:expand-from-previous-tree-state',
           item);
         pgBrowser.Node.callbacks.change_server_background(item, data);
@@ -1050,43 +1024,11 @@ define('pgadmin.browser.node', [
         return true;
       },
       removed: function(item) {
-        var self = this,
-          t = pgBrowser.tree,
-          pItem = t.parent(item),
-          pData = pItem && t.itemData(pItem),
-          pNode = pData && pgBrowser.Nodes[pData._type];
-
-        // Check node is a collection or not.
-        if (
-          pNode && pNode.is_collection && 'collection_count' in pData
-        ) {
-          pData.collection_count--;
-          t.setLabel(
-            pItem, {
-              label: (
-                _.escape(pData._label) + ' <span>(' + pData.collection_count + ')</span>'
-              ),
-            }
-          );
-        }
-
+        var self = this;
         setTimeout(function() {
           self.clear_cache.apply(self, item);
         }, 0);
       },
-      unloaded: function(item) {
-        var self = this,
-          t = pgBrowser.tree,
-          data = item && t.itemData(item);
-
-        // In case of unload remove the collection counter
-        if (self.is_collection &&  data === Object(data) &&'collection_count' in data) {
-          delete data.collection_count;
-          t.setLabel(item, {
-            label: _.escape(data._label),
-          });
-        }
-      },
       refresh: function(cmd, _item) {
         var self = this,
           t = pgBrowser.tree,
@@ -1232,8 +1174,7 @@ define('pgadmin.browser.node', [
           // Avoid unnecessary reloads
           var i = tree.selected(),
             d = i && tree.itemData(i),
-            n = i && d && pgBrowser.Nodes[d._type],
-            treeHierarchy = n.getTreeNodeHierarchy(i);
+            treeHierarchy = tree.getTreeNodeHierarchy(i);
 
           if (_.isEqual($(this).data('node-prop'), treeHierarchy)) {
             return;
@@ -1246,7 +1187,7 @@ define('pgadmin.browser.node', [
           removeNodeView(j[0]);
           /* getSchema is a schema for React. Get the react node view */
           if(that.getSchema) {
-            let treeNodeInfo = that.getTreeNodeHierarchy.apply(this, [item]);
+            let treeNodeInfo = pgBrowser.tree.getTreeNodeHierarchy(item);
             getNodeView(
               that.type, treeNodeInfo, 'properties', data, 'tab', j[0], this, onEdit
             );
@@ -1323,7 +1264,7 @@ define('pgadmin.browser.node', [
         }.bind(panel),
         onSqlHelp = function() {
           // Construct the URL
-          var server = that.getTreeNodeHierarchy(item).server;
+          var server = pgBrowser.tree.getTreeNodeHierarchy(item).server;
 
           var url = pgBrowser.utils.pg_help_path;
           if (server.server_type == 'ppas') {
@@ -1507,7 +1448,7 @@ define('pgadmin.browser.node', [
           removeNodeView(j[0]);
           /* getSchema is a schema for React. Get the react node view */
           if(that.getSchema) {
-            let treeNodeInfo = that.getTreeNodeHierarchy.apply(this, [item]);
+            let treeNodeInfo = pgBrowser.tree.getTreeNodeHierarchy(item);
             getNodeView(
               that.type, treeNodeInfo, action, data, 'dialog', j[0], this, onEdit,
               (nodeData)=>{
@@ -1884,7 +1825,7 @@ define('pgadmin.browser.node', [
         self = this,
         priority = -Infinity;
       var treeInfo = (_.isUndefined(item) || _.isNull(item)) ?
-        info || {} : this.getTreeNodeHierarchy(item);
+        info || {} : pgBrowser.tree.getTreeNodeHierarchy(item);
       var actionType = type in opURL ? opURL[type] : type;
       var itemID = with_id && d._type == self.type ? encodeURIComponent(d._id) : '';
 
@@ -1921,7 +1862,6 @@ define('pgadmin.browser.node', [
     Collection: pgBrowser.DataCollection,
     // Base class for Node Data Model
     Model: pgBrowser.DataModel,
-    getTreeNodeHierarchy: pgadminTreeNode.getTreeNodeHierarchyFromIdentifier.bind(pgBrowser),
     cache: function(url, node_info, level, data) {
       var cached = this.cached = this.cached || {},
         hash = url,
@@ -1938,7 +1878,7 @@ define('pgadmin.browser.node', [
         )), function(o) {
           return o.priority;
         }), function(o) {
-          hash = commonUtils.sprintf('%s/%s', hash, encodeURI(o._id));
+          hash = commonUtils.sprintf('%s_%s', hash, encodeURI(o._id));
         });
       }
 
diff --git a/web/pgadmin/browser/static/js/preferences.js b/web/pgadmin/browser/static/js/preferences.js
index c5eafacd2..98b006fc5 100644
--- a/web/pgadmin/browser/static/js/preferences.js
+++ b/web/pgadmin/browser/static/js/preferences.js
@@ -14,7 +14,7 @@ import * as Alertify from 'pgadmin.alertifyjs';
 import * as SqlEditorUtils from 'sources/sqleditor_utils';
 import pgWindow from 'sources/window';
 
-var modifyAnimation = require('sources/modify_animation');
+//var modifyAnimation = require('sources/modify_animation');
 
 const pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {};
 
@@ -91,10 +91,10 @@ _.extend(pgBrowser, {
           self.preference_version(self.generate_preference_version());
 
           pgBrowser.keyboardNavigation.init();
-          if(pgBrowser.tree) {
-            modifyAnimation.modifyAcitreeAnimation(self);
-            modifyAnimation.modifyAlertifyAnimation(self);
-          }
+          //          if(pgBrowser.tree) {
+          //            modifyAnimation.modifyAcitreeAnimation(self);
+          //            modifyAnimation.modifyAlertifyAnimation(self);
+          //          }
 
           // Initialize Tree saving/reloading
           pgBrowser.browserTreeState.init();
diff --git a/web/pgadmin/browser/static/js/toolbar.js b/web/pgadmin/browser/static/js/toolbar.js
index bc9c13a3d..9920cd629 100644
--- a/web/pgadmin/browser/static/js/toolbar.js
+++ b/web/pgadmin/browser/static/js/toolbar.js
@@ -123,7 +123,7 @@ export function initializeToolbar(panel, wcDocker) {
       var input = {},
         t = pgAdmin.Browser.tree,
         i = input.item || t.selected(),
-        d = i && i.length == 1 ? t.itemData(i) : undefined;
+        d = i  ? t.itemData(i) : undefined;
       pgAdmin.Browser.psql.psql_tool(d, i, true);
     }
   });
diff --git a/web/pgadmin/dashboard/static/js/dashboard.js b/web/pgadmin/dashboard/static/js/dashboard.js
index 529ba3b5f..6e6228304 100644
--- a/web/pgadmin/dashboard/static/js/dashboard.js
+++ b/web/pgadmin/dashboard/static/js/dashboard.js
@@ -272,16 +272,16 @@ define('pgadmin.dashboard', [
       // The server connected may not be the same one, which was selected, and
       // we do care out the current selected one only.
       if (item.length != 0) {
-        this.object_selected(item, itemData, pgBrowser.Nodes[itemData._type]);
+        this.object_selected(item, itemData);
       }
     },
 
     // Handle treeview clicks
-    object_selected: function(item, itemData, node) {
+    object_selected: function(item, itemData) {
       let self = this;
 
       if (itemData && itemData._type) {
-        var treeHierarchy = node.getTreeNodeHierarchy(item),
+        var treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
           url = NodesDashboard.url(itemData, item, treeHierarchy);
 
         if (url === null) {
@@ -1142,11 +1142,10 @@ define('pgadmin.dashboard', [
       } else {
         var t = pgBrowser.tree,
           i = t.selected(),
-          d = i && t.itemData(i),
-          n = i && d && pgBrowser.Nodes[d._type];
+          d = i && t.itemData(i);
 
         this.chartsDomObj && this.chartsDomObj.setPageVisible(dashboardVisible);
-        this.object_selected(i, d, n);
+        this.object_selected(i, d);
       }
     },
     can_take_action: function(m) {
diff --git a/web/pgadmin/misc/dependencies/static/js/dependencies.js b/web/pgadmin/misc/dependencies/static/js/dependencies.js
index 67377c9a5..2098b035f 100644
--- a/web/pgadmin/misc/dependencies/static/js/dependencies.js
+++ b/web/pgadmin/misc/dependencies/static/js/dependencies.js
@@ -168,7 +168,7 @@ define('misc.dependencies', [
         $container = panel.layout().scene().find('.pg-panel-content'),
         $msgContainer = $container.find('.pg-panel-depends-message'),
         $gridContainer = $container.find('.pg-panel-dependencies-container'),
-        treeHierarchy = node.getTreeNodeHierarchy(item);
+        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
 
       if (node) {
         /* We fetch the Dependencies and Dependencies tab only for
@@ -294,6 +294,128 @@ define('misc.dependencies', [
         }
       }
     },
+    showReactDependencies: function(item, data, node) {
+      let self = this,
+        msg = gettext('Please select an object in the tree view.'),
+        panel = this.dependenciesPanel,
+        $container = panel.layout().scene().find('.pg-panel-content'),
+        $msgContainer = $container.find('.pg-panel-depends-message'),
+        $gridContainer = $container.find('.pg-panel-dependencies-container'),
+        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
+        n_type = data._type,
+        url = node.generate_url_react(item, 'dependency');
+
+      if (node) {
+        /* We fetch the Dependencies and Dependencies tab only for
+         * those node who set the parameter hasDepends to true.
+         */
+        msg = gettext('No dependency information is available for the selected object.');
+        if (node.hasDepends) {
+          /* Updating the label for the 'field' type of the backbone model.
+           * Label should be "Database" if the node type is tablespace or role
+           * and dependencies tab is selected. For other nodes and dependencies tab
+           * it should be 'Restriction'.
+           */
+
+          this.dependenciesGrid.columns.models[2].set({
+            'label': gettext('Restriction'),
+          });
+
+          // Hide message container and show grid container.
+          $msgContainer.addClass('d-none');
+          $gridContainer.removeClass('d-none');
+
+          var timer = '';
+          $.ajax({
+            url: url,
+            type: 'GET',
+            beforeSend: function(xhr) {
+              xhr.setRequestHeader(pgAdmin.csrf_token_header, pgAdmin.csrf_token);
+              // Generate a timer for the request
+              timer = setTimeout(function() {
+                // notify user if request is taking longer than 1 second
+
+                $msgContainer.text(gettext('Fetching dependency information from the server...'));
+                $msgContainer.removeClass('d-none');
+                msg = '';
+
+              }, 1000);
+            },
+          })
+            .done(function(res) {
+              clearTimeout(timer);
+
+              if (res.length > 0) {
+
+                if (!$msgContainer.hasClass('d-none')) {
+                  $msgContainer.addClass('d-none');
+                }
+                $gridContainer.removeClass('d-none');
+
+                self.dependenciesData = res;
+
+                // Load only 100 rows
+                self.dependenciesCollection.reset(self.dependenciesData.splice(0, 100), {parse: true});
+
+                // Load more rows on scroll down
+                pgBrowser.Events.on(
+                  'pgadmin-browser:panel-dependencies:' +
+                wcDocker.EVENT.SCROLLED,
+                  self.__loadMoreRows
+                );
+
+              } else {
+                // Do not listen the scroll event
+                pgBrowser.Events.off(
+                  'pgadmin-browser:panel-dependencies:' +
+                wcDocker.EVENT.SCROLLED
+                );
+
+                self.dependenciesCollection.reset({silent: true});
+                $msgContainer.text(msg);
+                $msgContainer.removeClass('d-none');
+
+                if (!$gridContainer.hasClass('d-none')) {
+                  $gridContainer.addClass('d-none');
+                }
+              }
+
+
+            })
+            .fail(function(xhr, error, message) {
+              var _label = treeHierarchy[n_type].label;
+              pgBrowser.Events.trigger(
+                'pgadmin:node:retrieval:error', 'depends', xhr, error, message
+              );
+              if (!Alertify.pgHandleItemError(xhr, error, message, {
+                item: item,
+                info: treeHierarchy,
+              })) {
+                Alertify.pgNotifier(
+                  error, xhr,
+                  gettext('Error retrieving data from the server: %s', message || _label),
+                  function(alertMsg) {
+                    if(alertMsg === 'CRYPTKEY_SET') {
+                      self.showDependencies(item, data, node);
+                    } else {
+                      console.warn(arguments);
+                    }
+                  });
+              }
+              // show failed message.
+              $msgContainer.text(gettext('Failed to retrieve data from the server.'));
+            });
+        }
+      }
+      if (msg != '') {
+        $msgContainer.text(msg);
+        $msgContainer.removeClass('d-none');
+        if (!$gridContainer.hasClass('d-none')) {
+          $gridContainer.addClass('d-none');
+        }
+      }
+    },
+
     __loadMoreRows: function() {
       if (this.dependenciesPanel.length < 1) return ;
 
diff --git a/web/pgadmin/misc/dependents/static/js/dependents.js b/web/pgadmin/misc/dependents/static/js/dependents.js
index 6564979d7..e0766e767 100644
--- a/web/pgadmin/misc/dependents/static/js/dependents.js
+++ b/web/pgadmin/misc/dependents/static/js/dependents.js
@@ -168,7 +168,7 @@ define('misc.dependents', [
         $container = panel.layout().scene().find('.pg-panel-content'),
         $msgContainer = $container.find('.pg-panel-depends-message'),
         $gridContainer = $container.find('.pg-panel-dependents-container'),
-        treeHierarchy = node.getTreeNodeHierarchy(item);
+        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
 
       if (node) {
         /* We fetch the Dependencies and Dependents tab only for
diff --git a/web/pgadmin/misc/sql/static/js/sql.js b/web/pgadmin/misc/sql/static/js/sql.js
index 4abd054fa..c1722bee6 100644
--- a/web/pgadmin/misc/sql/static/js/sql.js
+++ b/web/pgadmin/misc/sql/static/js/sql.js
@@ -57,6 +57,9 @@ define('misc.sql', [
               pgBrowser.Events.on(
                 'pgadmin-browser:tree:selected', this.showSQL
               );
+              pgBrowser.Events.on(
+                'pgadmin-browser:tree:reactSelected', this.reactShowSQL
+              );
               pgBrowser.Events.on(
                 'pgadmin-browser:tree:refreshing', this.refreshSQL, this
               );
@@ -66,6 +69,7 @@ define('misc.sql', [
       } else {
         if ((sqlPanels[0].isVisible()) || sqlPanels.length != 1) {
           pgBrowser.Events.on('pgadmin-browser:tree:selected', this.showSQL);
+          pgBrowser.Events.on('pgadmin-browser:tree:reactSelected', this.reactShowSQL);
           pgBrowser.Events.on(
             'pgadmin-browser:tree:refreshing', this.refreshSQL, this
           );
@@ -92,6 +96,7 @@ define('misc.sql', [
        * through. We will wait for some time before fetching the Reversed
        * Engineering SQL.
        **/
+
       this.timeout && clearTimeout(this.timeout);
 
       var that = this;
@@ -102,7 +107,7 @@ define('misc.sql', [
             sql = '-- ' + gettext('No SQL could be generated for the selected object.');
             var n_type = data._type,
               url = node.generate_url(item, 'sql', data, true),
-              treeHierarchy = node.getTreeNodeHierarchy(item),
+              treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
               cache_flag = {
                 node_type: n_type,
                 url: url,
diff --git a/web/pgadmin/misc/statistics/static/js/statistics.js b/web/pgadmin/misc/statistics/static/js/statistics.js
index f0dbc6a3b..6298caef3 100644
--- a/web/pgadmin/misc/statistics/static/js/statistics.js
+++ b/web/pgadmin/misc/statistics/static/js/statistics.js
@@ -199,7 +199,7 @@ define('misc.statistics', [
          */
 
         // Avoid unnecessary reloads
-        var treeHierarchy = node.getTreeNodeHierarchy(item);
+        var treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
         var cache_flag = {
           node_type: node_type,
           url: url,
@@ -210,7 +210,7 @@ define('misc.statistics', [
         // Cache the current IDs for next time
         $(panel[0]).data('node-prop', cache_flag);
 
-        if (statisticsHelper.nodeHasStatistics(node, item)) {
+        if (statisticsHelper.nodeHasStatistics(pgBrowser, node, item)) {
           msg = '';
           var timer;
           // Set the url, fetch the data and update the collection
diff --git a/web/pgadmin/preferences/static/js/preferences.js b/web/pgadmin/preferences/static/js/preferences.js
index 6dd88151f..5b5d1087a 100644
--- a/web/pgadmin/preferences/static/js/preferences.js
+++ b/web/pgadmin/preferences/static/js/preferences.js
@@ -495,7 +495,7 @@ define('pgadmin.preferences', [
               view: {duration: 75},
             });
 
-            modifyAnimation.modifyAcitreeAnimation(pgBrowser, jTree.aciTree('api'));
+            if (jTree.aciTree('api')) modifyAnimation.modifyAcitreeAnimation(pgBrowser, jTree.aciTree('api'));
 
             this.show();
           },
diff --git a/web/pgadmin/static/bundle/app.js b/web/pgadmin/static/bundle/app.js
index c8bd8f74b..6b11fefea 100644
--- a/web/pgadmin/static/bundle/app.js
+++ b/web/pgadmin/static/bundle/app.js
@@ -13,11 +13,22 @@ define('app', [
   var initializeModules = function(Object) {
     for (var key in Object) {
       var module = Object[key];
-      if (module.init && typeof module.init == 'function') {
-        module.init();
+
+      if (module && module.init && typeof module.init == 'function') {
+        try {
+          module.init();
+        }
+        catch (e) {
+          console.warn(e.stack || e);
+        }
       }
-      else if (module.Init && typeof module.Init == 'function') {
-        module.Init();
+      else if (module && module.Init && typeof module.Init == 'function') {
+        try {
+          module.init();
+        }
+        catch (e) {
+          console.warn(e.stack || e);
+        }
       }
     }
   };
diff --git a/web/pgadmin/static/js/alertify/dialog.js b/web/pgadmin/static/js/alertify/dialog.js
index 6b7c41c50..27ba62a5f 100644
--- a/web/pgadmin/static/js/alertify/dialog.js
+++ b/web/pgadmin/static/js/alertify/dialog.js
@@ -10,7 +10,6 @@
 import gettext from '../gettext';
 import {DialogFactory} from './dialog_factory';
 import Backform from '../backform.pgadmin';
-import {getTreeNodeHierarchyFromIdentifier} from '../tree/pgadmin_tree_node';
 
 /**
  * This class can be extended to create new dialog boxes.
@@ -35,8 +34,8 @@ export class Dialog {
 
   retrieveAncestorOfTypeServer(item) {
     let serverInformation = null;
-    let aciTreeItem = item || this.pgBrowser.treeMenu.selected();
-    let treeNode = this.pgBrowser.treeMenu.findNodeByDomElement(aciTreeItem);
+    let aciTreeItem = item || this.pgBrowser.tree.selected();
+    let treeNode = this.pgBrowser.tree.findNodeByDomElement(aciTreeItem);
 
     if (treeNode) {
       let nodeData;
@@ -107,7 +106,7 @@ export class Dialog {
   }
 
   canExecuteOnCurrentDatabase(aciTreeItem) {
-    const treeInfo = getTreeNodeHierarchyFromIdentifier.apply(this.pgBrowser, [aciTreeItem]);
+    const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(aciTreeItem);
 
     if (treeInfo.database && treeInfo.database._label.indexOf('=') >= 0) {
       this.alertify.alert(
diff --git a/web/pgadmin/static/js/misc/statistics/statistics.js b/web/pgadmin/static/js/misc/statistics/statistics.js
index a004a61bd..1549db990 100644
--- a/web/pgadmin/static/js/misc/statistics/statistics.js
+++ b/web/pgadmin/static/js/misc/statistics/statistics.js
@@ -7,9 +7,9 @@
 //
 //////////////////////////////////////////////////////////////////////////
 
-export function nodeHasStatistics(node, item) {
+export function nodeHasStatistics(pgBrowser, node, item) {
   if(typeof(node.hasStatistics) === 'function') {
-    const treeHierarchy = node.getTreeNodeHierarchy(item);
+    const treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
     return node.hasStatistics(treeHierarchy);
   }
   return node.hasStatistics;
diff --git a/web/pgadmin/static/js/nodes/dashboard.js b/web/pgadmin/static/js/nodes/dashboard.js
index 137fde684..f4688cd10 100644
--- a/web/pgadmin/static/js/nodes/dashboard.js
+++ b/web/pgadmin/static/js/nodes/dashboard.js
@@ -12,7 +12,7 @@ import pgBrowser from 'pgadmin.browser';
 
 
 export function url(itemData, item, treeHierarchy) {
-  let treeNode = pgBrowser.treeMenu.findNodeByDomElement(item);
+  let treeNode = pgBrowser.tree.findNodeByDomElement(item);
   let return_url = null;
 
   if (treeNode) {
diff --git a/web/pgadmin/static/js/nodes/supported_database_node.js b/web/pgadmin/static/js/nodes/supported_database_node.js
index e174363ad..469ac47b3 100644
--- a/web/pgadmin/static/js/nodes/supported_database_node.js
+++ b/web/pgadmin/static/js/nodes/supported_database_node.js
@@ -8,6 +8,7 @@
 //////////////////////////////////////////////////////////////
 
 import {isValidTreeNodeData} from 'sources/tree/tree';
+import pgAdmin from 'sources/pgadmin';
 
 function checkAllowConnIfDatabaseNode(treeNodeData) {
   return (treeNodeData._type === 'database' && treeNodeData.allowConn)
@@ -24,7 +25,8 @@ export function enabled(tree, supportedNodes, treeNodeData, domTreeNode) {
   if (!isValidTreeNodeData(treeNodeData))
     return false;
 
-  let treeNode = tree.findNodeByDomElement(domTreeNode);
+  let _tree = tree ? tree : pgAdmin.Browser.tree;
+  let treeNode = _tree.findNodeByDomElement(domTreeNode);
   if (!treeNode) {
     return false;
   }
diff --git a/web/pgadmin/static/js/tree/pgadmin_tree_save_state.js b/web/pgadmin/static/js/tree/pgadmin_tree_save_state.js
index 1a1ac11fc..950d00528 100644
--- a/web/pgadmin/static/js/tree/pgadmin_tree_save_state.js
+++ b/web/pgadmin/static/js/tree/pgadmin_tree_save_state.js
@@ -150,12 +150,10 @@ _.extend(pgBrowser.browserTreeState, {
       });
   },
   update_cache: function(item) {
-
     let data = item && pgBrowser.tree.itemData(item),
-      node = data && pgBrowser.Nodes[data._type],
-      treeHierarchy = node.getTreeNodeHierarchy(item),
+      treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
       topParent = undefined,
-      pathIDs = pgBrowser.tree.pathId(item),
+      pathIDs = pgBrowser.tree.pathId(pgBrowser.tree.parent(item)),
       oldPath = pathIDs.join(),
       path = [],
       tmpIndex = -1;
@@ -208,8 +206,7 @@ _.extend(pgBrowser.browserTreeState, {
     let self= this,
       treeData = self.stored_state || {},
       data = item && pgBrowser.tree.itemData(item),
-      node = data && pgBrowser.Nodes[data._type],
-      treeHierarchy = node && node.getTreeNodeHierarchy(item);
+      treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
 
     if (treeHierarchy === null || !pgBrowser.tree.hasParent(item) || !(treeHierarchy.hasOwnProperty(self.parent)))
       return;
@@ -265,8 +262,7 @@ _.extend(pgBrowser.browserTreeState, {
     let self = this,
       treeData = self.stored_state || {},
       data = item && pgBrowser.tree.itemData(item),
-      node = data && pgBrowser.Nodes[data._type],
-      treeHierarchy = node && node.getTreeNodeHierarchy(item);
+      treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
 
 
     if (treeHierarchy === null || !pgBrowser.tree.hasParent(item) || !(treeHierarchy.hasOwnProperty(self.parent)))
@@ -305,7 +301,7 @@ _.extend(pgBrowser.browserTreeState, {
 
             let index = tmpItemData.indexOf(data.id);
 
-            pgBrowser.tree.toggle(item);
+            pgBrowser.tree.open(item);
 
             if (index == (tmpItemData.length - 1 )) {
               let tIndex = treeData[treeHierarchy[self.parent]['_id']]['paths'].indexOf(tData);
@@ -322,8 +318,7 @@ _.extend(pgBrowser.browserTreeState, {
   },
   update_database_status: function(item) {
     let data = item && pgBrowser.tree.itemData(item),
-      node = data && pgBrowser.Nodes[data._type],
-      treeHierarchy = node.getTreeNodeHierarchy(item);
+      treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
 
     if (treeHierarchy.hasOwnProperty('database')) {
       let databaseItem = treeHierarchy['database']['id'],
@@ -374,8 +369,7 @@ _.extend(pgBrowser.browserTreeState, {
   select_tree_item(item) {
     let treeData = this.stored_state || {},
       data = item && pgBrowser.tree.itemData(item),
-      node = data && pgBrowser.Nodes[data._type],
-      treeHierarchy = node && node.getTreeNodeHierarchy(item),
+      treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
       tmpTreeData = treeData[treeHierarchy[this.parent]['_id']];
 
 
